﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ZedGraph;

namespace QCW
{
    public partial class WaveConfig : Form
    {

        RSComStruct myRSComStruct = new RSComStruct();

        public List<UnitStatus> UnitStatusList = new List<UnitStatus>();

        uint SampleNum = 0;

        Int16[] RecBuf = new Int16[10005];

        public class UnitStatus
        {

            public UInt32 PowerSet { get; set; }
            public UInt32 PowerDelayTime { get; set; }


            public UnitStatus()
            {
                PowerSet = 0;
                PowerDelayTime = 1;
            }
        }

        public WaveConfig()
        {
            InitializeComponent();
        }

        private void Dispquxian( )
        {
            if (listView1.Items.Count < 2)
                return;

            this.zedGraphControl1.GraphPane.CurveList.Clear();
             
            //设置1200个点,假设每50毫秒更新一次,刚好检测1分钟,一旦构造后将不能更改这个值
            RollingPointPairList list = new RollingPointPairList(listView1.Items.Count);
            double x=0,y=0;
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                 y= Convert.ToDouble(listView1.Items[i].SubItems[1].Text);
                 x= Convert.ToDouble(listView1.Items[i].SubItems[2].Text);
                list.Add(x,y);
            }
            //开始，增加的线是没有数据点的(也就是list为空)
            //增加一条名称:Voltage，颜色Color.Bule，无符号，无数据的空线条
            LineItem curve = this.zedGraphControl1.GraphPane.AddCurve("Power", list, Color.Red, SymbolType.None);          //开始
            this.zedGraphControl1.GraphPane.XAxis.Scale.Min = 0;        //X轴最小值0
            this.zedGraphControl1.GraphPane.XAxis.Scale.Max = x;    //X轴最大30
            this.zedGraphControl1.GraphPane.XAxis.Scale.MinorStep = 0.5;//X轴小步长1,也就是小间隔
            //改变轴的刻度
            zedGraphControl1.AxisChange();
            //第四步:调用Form.Invalidate()方法更新图表
            zedGraphControl1.Invalidate();
        }

        private void SetSize()
        {
            zedGraphControl1.Location = new Point(10, 10);
            zedGraphControl1.Size = new Size(ClientRectangle.Width - 100, ClientRectangle.Height - 200);
        } 

        private void WaveConfig_Load(object sender, EventArgs e)
        {
            this.zedGraphControl1.GraphPane.Title.Text = "Wave";
            this.zedGraphControl1.GraphPane.Title.FontSpec.FontColor = Color.Blue;
            this.zedGraphControl1.GraphPane.Title.FontSpec.Size = 30f;

            this.zedGraphControl1.GraphPane.XAxis.Title.Text = "Time(*0.1ms)";
            this.zedGraphControl1.GraphPane.XAxis.Title.FontSpec.FontColor = Color.Blue;
            this.zedGraphControl1.GraphPane.XAxis.Title.FontSpec.Size = 20f;

            this.zedGraphControl1.GraphPane.YAxis.Title.Text = "Power";
            this.zedGraphControl1.GraphPane.YAxis.Title.FontSpec.FontColor = Color.Blue;
            this.zedGraphControl1.GraphPane.YAxis.Title.FontSpec.Size = 20f;
            //刻度值字体大小、颜色
            this.zedGraphControl1.GraphPane.XAxis.Scale.FontSpec.Size = 20f;
            this.zedGraphControl1.GraphPane.XAxis.Scale.FontSpec.FontColor = Color.Black;

            this.zedGraphControl1.GraphPane.YAxis.Scale.FontSpec.Size = 20f;
            this.zedGraphControl1.GraphPane.YAxis.Scale.Min = 0;
            this.zedGraphControl1.GraphPane.YAxis.Scale.Max = 110;
            this.zedGraphControl1.GraphPane.YAxis.Scale.MinorStep = 5;//小步长
            this.zedGraphControl1.GraphPane.YAxis.Scale.MajorStep = 10;//小步长

            //显示网格线  
            this.zedGraphControl1.GraphPane.YAxis.MajorGrid.IsVisible = true;
            this.zedGraphControl1.GraphPane.XAxis.MajorGrid.IsVisible = true;
            //legend  
            this.zedGraphControl1.GraphPane.Legend.FontSpec.Size = 10f;
            this.zedGraphControl1.GraphPane.Legend.Position = LegendPos.InsideTopRight;
            //面板填充颜色  
            this.zedGraphControl1.GraphPane.Chart.Fill = new Fill(Color.White, Color.LightGray, 45.0f);
            //设置窗口大小  
           // SetSize();
            //更新画面  
            this.zedGraphControl1.AxisChange();
            this.zedGraphControl1.Refresh();  

            textBox1.Text = "0";
            textBox2.Text = "0";
            textBox3.Text = "0";
            textBox4.Text = "0";
            textBox5.Text = "10";
            textBox6.Text = "0";
            textBox7.Text = "1122334455667788";
        }

        public float StrToFloat(object FloatString)
        {
            try
            {
                float f = (float)Convert.ToSingle(FloatString);
                return f;
            }
            catch (FormatException)
            {
                return (float)0.00;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SampleNum++;
            UnitStatusList.Add(new UnitStatus());
            try  //
            {
                UnitStatusList[(int)(SampleNum - 1)].PowerSet = (UInt32)Convert.ToUInt32(textBox5.Text);
                UnitStatusList[(int)(SampleNum - 1)].PowerDelayTime = (UInt32)Convert.ToUInt32(textBox6.Text);

                if (SampleNum > 1)
                {
                    if(UnitStatusList[(int)(SampleNum - 1)].PowerDelayTime<=UnitStatusList[(int)(SampleNum -2)].PowerDelayTime)
                    {
                        SampleNum--;
                        MessageBox.Show("Please check Time");
                    }
                }
                uint i=UnitStatusList[(int)(SampleNum - 1)].PowerDelayTime;
                i++;
                textBox6.Text =i.ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                return;
            }
            WaveEditPro(SampleNum);
        }

        private void WaveEditPro(UInt32 modlenum)
        {
            this.listView1.BeginUpdate();   //数据更新，UI暂时挂起，直到EndUpdate绘制控件，可以有效避免闪烁并大大提高加载速度 

            if (this.listView1.Items.Count > 0)
            {

                this.listView1.Items.Clear();

            }


            for (int i = 0; i < modlenum; i++)   //添加10行数据 
            {
                ListViewItem lvi = new ListViewItem();
                ImageList imgList = new ImageList();
                imgList.ImageSize = new Size(1, 15);

                this.listView1.SmallImageList = imgList;
                

                if (i > 0)
                {
                    if (UnitStatusList[i].PowerDelayTime > UnitStatusList[i - 1].PowerDelayTime)
                    {
                        lvi.Text = i.ToString();
                        lvi.SubItems.Add(UnitStatusList[i].PowerSet.ToString());

                        lvi.SubItems.Add(UnitStatusList[i].PowerDelayTime.ToString());
                        this.listView1.Items.Add(lvi);
                    }
                    else
                    {
                        MessageBox.Show("Please Check Power Time");
                        break;
                    }
                }
                else
                {
                    lvi.Text = i.ToString();
                    lvi.SubItems.Add(UnitStatusList[i].PowerSet.ToString());

                    lvi.SubItems.Add(UnitStatusList[i].PowerDelayTime.ToString());
                    this.listView1.Items.Add(lvi);
                } 
                this.listView1.Items[i].UseItemStyleForSubItems = false;

            }

            this.listView1.EndUpdate();  //结束数据处理，UI界面一次性绘制。 
            Dispquxian();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            byte[] Dadabuf = new byte[1000];
            int datainlen;
            int i = 0;
            UInt32 uint32t = 0;
            try  //
            {
                uint32t = (UInt32)Convert.ToUInt32(textBox2.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                return;
            }
            Dadabuf[i++] = (byte)uint32t;
            datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x75, Dadabuf, i, ref myRSComStruct);
            if (datainlen > 0)
            {
                if (myRSComStruct.RecDada[0] == 0xaa)
                {
                }
                else
                {
                    MessageBox.Show("Read Fail");
                    return;
                }
            }
            else
            {
                MessageBox.Show("Communication Timeout");
                return;
            }

            UInt32[] IDTable = new UInt32[] { 0x04300010, 0x04300011,0x04300012, 0x04300013, 0x04300014};
            try  //
            {
                byte[] datainbuf = new byte[1000];
                i = 0;

                uint32t = 0x00000001;
                byte[] mybyte = new byte[4];

                UInt32 inttemp = 0;


                foreach (UInt32 idnum in IDTable)
                {
                    uint32t = idnum;
                    mybyte = BitConverter.GetBytes(uint32t);
                    Dadabuf[i++] = mybyte[3];
                    Dadabuf[i++] = mybyte[2];
                    Dadabuf[i++] = mybyte[1];
                    Dadabuf[i++] = mybyte[0];
                }

                datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x31, Dadabuf, i, ref myRSComStruct);
                if (datainlen > 0)
                {

                    int ParaNum = myRSComStruct.RecLength / 8;

                    for (i = 0; i < ParaNum; i++)
                    {
                        mybyte[3] = myRSComStruct.RecDada[8 * i];
                        mybyte[2] = myRSComStruct.RecDada[8 * i + 1];
                        mybyte[1] = myRSComStruct.RecDada[8 * i + 2];
                        mybyte[0] = myRSComStruct.RecDada[8 * i + 3];
                        UInt32 IDnum = BitConverter.ToUInt32(mybyte, 0);
                        IDnum &= 0x0000ffff;
                        mybyte[3] = myRSComStruct.RecDada[8 * i + 4];
                        mybyte[2] = myRSComStruct.RecDada[8 * i + 5];
                        mybyte[1] = myRSComStruct.RecDada[8 * i + 6];
                        mybyte[0] = myRSComStruct.RecDada[8 * i + 7];
                        switch (IDnum)
                        {
                            case 0x00000010:
                                inttemp = BitConverter.ToUInt32(mybyte, 0);
                                textBox1.Text = inttemp.ToString();
                                break;
                            case 0x00000011:
                                inttemp = BitConverter.ToUInt32(mybyte, 0);
                                textBox2.Text = inttemp.ToString();
                                break;
                            case 0x00000012:
                                inttemp = BitConverter.ToUInt32(mybyte, 0);
                                textBox3.Text = inttemp.ToString();
                                break;
                            case 0x00000013:
                                inttemp = BitConverter.ToUInt32(mybyte, 0);
                                textBox4.Text = inttemp.ToString();
                                break;
                            case 0x00000014:
                                SampleNum = BitConverter.ToUInt32(mybyte, 0);
                                if(SampleNum==0)SampleNum=1;
                                break;
                            default:
                                break;
                        }
                    }

                    i = 0;
                    for (UInt32 idnum = 0; idnum < SampleNum; idnum++)
                    {
                        uint32t = idnum+0x04300200;
                        mybyte = BitConverter.GetBytes(uint32t);
                        Dadabuf[i++] = mybyte[3];
                        Dadabuf[i++] = mybyte[2];
                        Dadabuf[i++] = mybyte[1];
                        Dadabuf[i++] = mybyte[0];
                        UnitStatusList.Add(new UnitStatus());

                    }

                    datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x31, Dadabuf, i, ref myRSComStruct);
                    if (datainlen > 0)
                    {
                         ParaNum = myRSComStruct.RecLength / 8;

                        for (i = 0; i < ParaNum; i++)
                        {
                            mybyte[3] = myRSComStruct.RecDada[8 * i];
                            mybyte[2] = myRSComStruct.RecDada[8 * i + 1];
                            mybyte[1] = myRSComStruct.RecDada[8 * i + 2];
                            mybyte[0] = myRSComStruct.RecDada[8 * i + 3];
                            UInt32 IDnum = BitConverter.ToUInt32(mybyte, 0);
                            IDnum &= 0x0000ffff;
                            mybyte[3] = myRSComStruct.RecDada[8 * i + 4];
                            mybyte[2] = myRSComStruct.RecDada[8 * i + 5];
                            mybyte[1] = myRSComStruct.RecDada[8 * i + 6];
                            mybyte[0] = myRSComStruct.RecDada[8 * i + 7];
                            if (IDnum >= 0x0200 && IDnum < 0x02fa)
                            {
                                inttemp = BitConverter.ToUInt32(mybyte, 0);
                                UnitStatusList[(int)(IDnum - 0x0200)].PowerSet = (uint)(inttemp&0x000000ff);
                                UnitStatusList[(int)(IDnum - 0x0200)].PowerDelayTime = (uint)(inttemp >> 16);
                            }
                        }
                        WaveEditPro(SampleNum);
                    }

                    MessageBox.Show("Read Success");
                }
                else
                {
                    MessageBox.Show("Communication Timeout");
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            try  //
            {
                byte[] Dadabuf = new byte[1000];
                byte[] datainbuf = new byte[1000];
                int datainlen;
                int i = 0;

                UInt32 uint32t = 0x00000001;
                byte[] mybyte = new byte[4];


                uint32t = 0x04300010; //总波形数
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                try  //
                {
                    uint32t = (UInt32)Convert.ToUInt32(textBox1.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                    return;
                }
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];

                uint32t = 0x04300011; //当前波形号
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                try  //
                {
                    uint32t = (UInt32)Convert.ToUInt32(textBox2.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                    return;
                }
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];

                uint32t = 0x04300012; //脉冲重复次数
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                try  //
                {
                    uint32t = (UInt32)Convert.ToUInt32(textBox3.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                    return;
                }
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];

                uint32t = 0x04300013; //脉冲间隔时间
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                try  //
                {
                    uint32t = (UInt32)Convert.ToUInt32(textBox4.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                    return;
                }
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];

                uint32t = 0x04300014; //脉冲波形总段数
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                try  //
                {
                    uint32t = SampleNum;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                    return;
                }
                mybyte = BitConverter.GetBytes(uint32t);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];

                for (UInt32 j = 0; j < SampleNum; j++)
                {
                    uint32t = 0x04300200+j; //脉冲波形总段数
                    mybyte = BitConverter.GetBytes(uint32t);
                    Dadabuf[i++] = mybyte[3];
                    Dadabuf[i++] = mybyte[2];
                    Dadabuf[i++] = mybyte[1];
                    Dadabuf[i++] = mybyte[0];
                    try  //
                    {
                        uint32t = UnitStatusList[(int)j].PowerDelayTime;
                        uint32t <<= 16;
                        uint32t += UnitStatusList[(int)j].PowerSet;
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                        return;
                    }
                    mybyte = BitConverter.GetBytes(uint32t);
                    Dadabuf[i++] = mybyte[3];
                    Dadabuf[i++] = mybyte[2];
                    Dadabuf[i++] = mybyte[1];
                    Dadabuf[i++] = mybyte[0];
                }

                    datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x32, Dadabuf, i, ref myRSComStruct);
                if (datainlen > 0)
                {
                    if (myRSComStruct.Para == 0xaa)
                        MessageBox.Show("下载成功");
                    else MessageBox.Show("没有权限，无法下载");
                }
                else
                {
                    MessageBox.Show("通讯超时，设备没有回应，请检查通讯接口是否插好或者设备是否上电，或者串口选择是否正确！");
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return;
            }
        }

        private static byte[] strToHexByte2(string HexString)
        {
            byte[] tt = null;
            if (HexString == "")
            {
                MessageBox.Show("Please Input data");
                return tt;
            }
            try
            {
                byte[] returnBytes = new byte[HexString.Length / 2];
                for (int i = 0; i < returnBytes.Length; i++)
                {
                    returnBytes[i] = Convert.ToByte(HexString.Substring(i * 2, 2), 16);
                }
                return returnBytes;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return tt;
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            try  //
            {
                byte[] Dadabuf = new byte[1000];
                byte[] datainbuf = new byte[1000];
                int datainlen;


                Dadabuf = strToHexByte2(textBox7.Text);

                if (Dadabuf == null) return;

                if (Dadabuf.Length != 8)
                {
                    MessageBox.Show("请输入8字节序列号");
                    return;
                }

                datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x36, Dadabuf, 8, ref myRSComStruct);
                if (datainlen > 0)
                {
                    if (myRSComStruct.RecDada[0] == 0xaa)
                    {
                        MessageBox.Show("验证通过");
                    }
                    else if (myRSComStruct.RecDada[0] == 0xcc)
                    {
                        MessageBox.Show("密码错误次数过多，请联系锐科技术人员解除锁定");
                    }
                    else
                    {
                        MessageBox.Show("验证失败");
                    }
                }
                else
                {
                    MessageBox.Show("通讯超时，设备没有回应，请检查通讯接口是否插好或者设备是否上电，或者串口选择是否正确！");
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return;
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            int i = 0;
            textBox6.Text = i.ToString();
            SampleNum = 0;

            WaveEditPro(SampleNum);
            this.zedGraphControl1.GraphPane.CurveList.Clear();

            this.zedGraphControl1.GraphPane.XAxis.Scale.Min = 0;        //X轴最小值0
            this.zedGraphControl1.GraphPane.XAxis.Scale.Max = 1;    //X轴最大30
            this.zedGraphControl1.GraphPane.XAxis.Scale.MinorStep = 1;//X轴小步长1,也就是小间隔
            //改变轴的刻度
            zedGraphControl1.AxisChange();
            //第四步:调用Form.Invalidate()方法更新图表
            zedGraphControl1.Invalidate();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0)
            {
                return;
            }
            if (listView1.Items.Count < 3) return;
            listView1.BeginUpdate();
            if (listView1.SelectedItems[0].Index > 0)
            {
                foreach (ListViewItem lvi in listView1.SelectedItems)
                {
                    ListViewItem lviSelectedItem = lvi;
                    int indexSelectedItem = lvi.Index;
                    listView1.Items.RemoveAt(indexSelectedItem);
                    listView1.Items[indexSelectedItem-1].Selected=true;
                }
                
            }
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                listView1.Items[i].Text = i.ToString();
            }
            listView1.EndUpdate();
            if (listView1.Items.Count > 0 && listView1.SelectedItems.Count > 0)
            {
                listView1.Focus();
                listView1.SelectedItems[0].Focused = true;
                listView1.SelectedItems[0].EnsureVisible();
            }

            UnitStatusList.Clear();
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList.Add(new UnitStatus());
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
            }
            SampleNum = (uint)listView1.Items.Count;

            Dispquxian();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0)
            {
                return;
            }
            if (listView1.Items.Count < 3) return;
            listView1.BeginUpdate();
            if (listView1.SelectedItems[0].Index > 0)
            {
                foreach (ListViewItem lvi in listView1.SelectedItems)
                {
                    ListViewItem lviSelectedItem = lvi;
                    int indexSelectedItem = lvi.Index;
                    listView1.Items.RemoveAt(indexSelectedItem);
                    listView1.Items.Insert(indexSelectedItem - 1, lviSelectedItem);
                }
            }
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                listView1.Items[i].Text = i.ToString();
            }
            listView1.EndUpdate();
            if (listView1.Items.Count > 0 && listView1.SelectedItems.Count > 0)
            {
                listView1.Focus();
                listView1.SelectedItems[0].Focused = true;
                listView1.SelectedItems[0].EnsureVisible();
            }

            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
            }

            UnitStatusList.Clear();
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList.Add(new UnitStatus());
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
                if (i > 1)
                {
                    if (UnitStatusList[(int)(i)].PowerDelayTime <= UnitStatusList[(int)(i - 1)].PowerDelayTime)
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Red;
                        listView1.EndUpdate();
                    }
                    else
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Transparent;
                        listView1.EndUpdate();
                    }
                }
            }
            SampleNum = (uint)listView1.Items.Count;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            byte[] Dadabuf = new byte[1000];
            int datainlen;
            int i = 0;
            textBox1.Text = "0";
            datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x73, Dadabuf, i, ref myRSComStruct);
            if (datainlen > 0)
            {   
                MessageBox.Show("Fdisk Success");    
            }
            else
            {
                 MessageBox.Show("Communication Timeout");
                 return;
            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            byte[] Dadabuf = new byte[1000];
            int datainlen;
            int i = 0;
            datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x74, Dadabuf, i, ref myRSComStruct);
            if (datainlen > 0)
            {
                if (myRSComStruct.RecDada[0] == 0xaa)
                {
                    MessageBox.Show("Write Success");
                }
                else
                {
                    MessageBox.Show("Write Fail");
                }
            }
            else
            {
                MessageBox.Show("Communication Timeout");
                return;
            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            byte[] Dadabuf = new byte[1000];
            int datainlen;
            int i = 0;
            UInt32 uint32t = 0;
            try  //
            {
                uint32t = (UInt32)Convert.ToUInt32(textBox2.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
                return;
            }
            Dadabuf[i++] = (byte)uint32t;
            datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x75, Dadabuf, i, ref myRSComStruct);
            if (datainlen > 0)
            {
                if (myRSComStruct.RecDada[0] == 0xaa)
                {
                    MessageBox.Show("Read Success");
                }
                else
                {
                    MessageBox.Show("Read Fail");
                }
            }
            else
            {
                MessageBox.Show("Communication Timeout");
                return;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if(this.listView1.FocusedItem==null)
            {
                MessageBox.Show("Err!No Insert add/r/n");
                return;
            }
            SampleNum++;
            //UnitStatus ttUnitStatus = new UnitStatus();
            //try  //
            //{
            //    ttUnitStatus.PowerSet = (UInt32)Convert.ToUInt32(textBox5.Text);
            //    ttUnitStatus.PowerDelayTime = (UInt32)Convert.ToUInt32(textBox6.Text);
            //}
            //catch (Exception ex)
            //{
            //    MessageBox.Show("输入数据格式不正确/r/n" + ex.ToString());
            //    return;
            //}
            //UnitStatusList.Insert(listView1.SelectedItems[0].Index,ttUnitStatus);
            //WaveEditPro(SampleNum);

            if (listView1.SelectedItems.Count == 0)
            {
                return;
            }
            if (listView1.Items.Count < 3) return;
            listView1.BeginUpdate();
            if (listView1.SelectedItems[0].Index > 0)
            {
                foreach (ListViewItem lvi in listView1.SelectedItems)
                {
                    ListViewItem lviSelectedItem = lvi;
                    int indexSelectedItem = lvi.Index;
                    ListViewItem newListViewItem = new ListViewItem();
                    newListViewItem.SubItems.Add(textBox5.Text);
                    newListViewItem.SubItems.Add(textBox6.Text);
                    listView1.Items.Insert(indexSelectedItem, newListViewItem);
                }
            }
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                listView1.Items[i].Text = i.ToString();
            }
            listView1.EndUpdate();
            if (listView1.Items.Count > 0 && listView1.SelectedItems.Count > 0)
            {
                listView1.Focus();
                listView1.SelectedItems[0].Focused = true;
                listView1.SelectedItems[0].EnsureVisible();
            }

            UnitStatusList.Add(new UnitStatus());
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
            }
            uint j = (UInt32)Convert.ToUInt32(textBox6.Text);
            j++;
            textBox6.Text = j.ToString();

            UnitStatusList.Clear();
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList.Add(new UnitStatus());
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
                if (i > 1)
                {
                    if (UnitStatusList[(int)(i )].PowerDelayTime <= UnitStatusList[(int)(i - 1)].PowerDelayTime)
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Red;
                        listView1.EndUpdate();
                    }
                    else
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Transparent;
                        listView1.EndUpdate();
                    }
                }
            }
            SampleNum = (uint)listView1.Items.Count;
            Dispquxian();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0)
            {
                return;
            }
            if (listView1.Items.Count < 3) return;
            listView1.BeginUpdate();
            int indexMaxSelectedItem = listView1.SelectedItems[listView1.SelectedItems.Count - 1].Index;
            if (indexMaxSelectedItem < listView1.Items.Count - 1)
            {
                for (int i = listView1.SelectedItems.Count - 1; i >= 0; i--)
                {
                    ListViewItem lviSelectedItem = listView1.SelectedItems[i];
                    int indexSelectedItem = lviSelectedItem.Index;
                    listView1.Items.RemoveAt(indexSelectedItem);
                    listView1.Items.Insert(indexSelectedItem + 1, lviSelectedItem);
                }
            }
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                listView1.Items[i].Text = i.ToString();
            }
            listView1.EndUpdate();
            if (listView1.Items.Count > 0 && listView1.SelectedItems.Count > 0)
            {
                listView1.Focus();
                listView1.SelectedItems[listView1.SelectedItems.Count - 1].Focused = true;
                listView1.SelectedItems[listView1.SelectedItems.Count - 1].EnsureVisible();
            }

            for(int i=0;i<listView1.Items.Count;i++)
            {
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
            }

            UnitStatusList.Clear();
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList.Add(new UnitStatus());
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
                if (i > 1)
                {
                    if (UnitStatusList[(int)(i)].PowerDelayTime <= UnitStatusList[(int)(i - 1)].PowerDelayTime)
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Red;
                        listView1.EndUpdate();
                    }
                    else
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Transparent;
                        listView1.EndUpdate();
                    }
                }
            }
            SampleNum = (uint)listView1.Items.Count;
        }

        private void button13_Click(object sender, EventArgs e)
        {
            Dispquxian();
        }


        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            UInt32 PowerSet = (UInt32)Convert.ToUInt32(listView1.SelectedItems[0].SubItems[1].Text);
            UInt32 PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.SelectedItems[0].SubItems[2].Text);
            WaveParaChange SetPowerWindow = new WaveParaChange(PowerSet, PowerDelayTime);
            SetPowerWindow.ShowDialog();

            PowerSet = SetPowerWindow.Power;
            PowerDelayTime = SetPowerWindow.Time;

            listView1.BeginUpdate();
            if (listView1.SelectedItems[0].Index >= 0)
            {
                foreach (ListViewItem lvi in listView1.SelectedItems)
                {
                    ListViewItem lviSelectedItem = lvi;
                    int indexSelectedItem = lvi.Index;
                    ListViewItem newListViewItem = new ListViewItem();
                    listView1.Items.RemoveAt(indexSelectedItem);
                    newListViewItem.SubItems.Add(PowerSet.ToString());
                    newListViewItem.SubItems.Add(PowerDelayTime.ToString());
                    listView1.Items.Insert(indexSelectedItem, newListViewItem);
                }
            }
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                listView1.Items[i].Text = i.ToString();
            }
            listView1.EndUpdate();


            UnitStatusList.Clear();
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                UnitStatusList.Add(new UnitStatus());
                UnitStatusList[i].PowerSet = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[1].Text);
                UnitStatusList[i].PowerDelayTime = (UInt32)Convert.ToUInt32(listView1.Items[i].SubItems[2].Text);
                if (i > 1)
                {
                    if (UnitStatusList[(int)(i)].PowerDelayTime <= UnitStatusList[(int)(i - 1)].PowerDelayTime)
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Red;
                        listView1.EndUpdate();
                    }
                    else
                    {
                        listView1.BeginUpdate();
                        listView1.Items[i].BackColor = Color.Transparent;
                        listView1.EndUpdate();
                    }
                }
            }
            SampleNum = (uint)listView1.Items.Count;
            Dispquxian();
        }

    }
}
